<html>
<head>
<title>OgreCamera.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreCamera.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreCamera_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Camera_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Camera_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// Default options</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreMovableObject_8h.html">OgreMovableObject.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Matrices &amp; Vectors</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgreMatrix4_8h.html">OgreMatrix4.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="OgrePlane_8h.html">OgrePlane.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="OgreQuaternion_8h.html">OgreQuaternion.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &quot;<a class="code" href="OgreFrustum_8h.html">OgreFrustum.h</a>&quot;</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &quot;<a class="code" href="OgreRay_8h.html">OgreRay.h</a>&quot;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &quot;<a class="code" href="OgrePlaneBoundedVolume_8h.html">OgrePlaneBoundedVolume.h</a>&quot;</span>
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="keyword">namespace </span>Ogre {
<a name="l00049"></a>00049 
<a name="l00085"></a><a class="code" href="classOgre_1_1Camera.html">00085</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent either a vi...">Frustum</a>
<a name="l00086"></a>00086     {
<a name="l00087"></a>00087     <span class="keyword">public</span>:
<a name="l00090"></a><a class="code" href="classOgre_1_1Camera_1_1Listener.html">00090</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Camera_1_1Listener.html" title="Listener interface so you can be notified of Camera events.">Listener</a> 
<a name="l00091"></a>00091         {
<a name="l00092"></a>00092         <span class="keyword">public</span>:
<a name="l00093"></a><a class="code" href="classOgre_1_1Camera_1_1Listener.html#a1a6a6f01f51426220de617805ec9eb71">00093</a>             <a class="code" href="classOgre_1_1Camera_1_1Listener.html#a1a6a6f01f51426220de617805ec9eb71">Listener</a>() {}
<a name="l00094"></a><a class="code" href="classOgre_1_1Camera_1_1Listener.html#a7796c4d59af00e54c29d19ced8627ad0">00094</a>             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Camera_1_1Listener.html#a7796c4d59af00e54c29d19ced8627ad0">~Listener</a>() {}
<a name="l00095"></a>00095 
<a name="l00097"></a><a class="code" href="classOgre_1_1Camera_1_1Listener.html#a118a99ab616bd2e1648c335afda174c9">00097</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> cameraPreRenderScene(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam)
<a name="l00098"></a>00098                         { (void)cam; }
<a name="l00099"></a>00099 
<a name="l00101"></a><a class="code" href="classOgre_1_1Camera_1_1Listener.html#a9359c80e745123e503311edbfc1d829a">00101</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> cameraPostRenderScene(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam)
<a name="l00102"></a>00102                         { (void)cam; }
<a name="l00103"></a>00103 
<a name="l00105"></a><a class="code" href="classOgre_1_1Camera_1_1Listener.html#a7195d8b8c12193eda52cc747262bd35b">00105</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> cameraDestroyed(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam)
<a name="l00106"></a>00106                         { (void)cam; }
<a name="l00107"></a>00107 
<a name="l00108"></a>00108         };
<a name="l00109"></a>00109     <span class="keyword">protected</span>:
<a name="l00111"></a><a class="code" href="classOgre_1_1Camera.html#a6833271b9f0f8670cd3435336b98e14e">00111</a>         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a> *<a class="code" href="classOgre_1_1Camera.html#a6833271b9f0f8670cd3435336b98e14e" title="Scene manager responsible for the scene.">mSceneMgr</a>;
<a name="l00112"></a>00112 
<a name="l00114"></a><a class="code" href="classOgre_1_1Camera.html#a7ef9be8a19008bb71056ed1f3d59b296">00114</a>         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="classOgre_1_1Camera.html#a7ef9be8a19008bb71056ed1f3d59b296" title="Camera orientation, quaternion style.">mOrientation</a>;
<a name="l00115"></a>00115 
<a name="l00117"></a><a class="code" href="classOgre_1_1Camera.html#a81cf2ce7174f9062d8b91f5d44e0cf83">00117</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Camera.html#a81cf2ce7174f9062d8b91f5d44e0cf83" title="Camera position - default (0,0,0)">mPosition</a>;
<a name="l00118"></a>00118 
<a name="l00120"></a><a class="code" href="classOgre_1_1Camera.html#a10727692997e136c9a58fbb35f42050f">00120</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="classOgre_1_1Camera.html#a10727692997e136c9a58fbb35f42050f" title="Derived orientation/position of the camera, including reflection.">mDerivedOrientation</a>;
<a name="l00121"></a><a class="code" href="classOgre_1_1Camera.html#a142ab7c933d2b458e7e159b5f44df26a">00121</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Camera.html#a142ab7c933d2b458e7e159b5f44df26a">mDerivedPosition</a>;
<a name="l00122"></a>00122 
<a name="l00124"></a><a class="code" href="classOgre_1_1Camera.html#abb6de92f758b9739a55fb3a64a5c3ae3">00124</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="classOgre_1_1Camera.html#abb6de92f758b9739a55fb3a64a5c3ae3" title="Real world orientation/position of the camera.">mRealOrientation</a>;
<a name="l00125"></a><a class="code" href="classOgre_1_1Camera.html#a9ae8e11e9fe456ab2d5878d181829350">00125</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Camera.html#a9ae8e11e9fe456ab2d5878d181829350">mRealPosition</a>;
<a name="l00126"></a>00126 
<a name="l00128"></a><a class="code" href="classOgre_1_1Camera.html#a569908afe5cfe82e20d5b1779a4ff4c7">00128</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Camera.html#a569908afe5cfe82e20d5b1779a4ff4c7" title="Whether to yaw around a fixed axis.">mYawFixed</a>;
<a name="l00130"></a><a class="code" href="classOgre_1_1Camera.html#a62932b0c160f8a9fbccb7740f6aa2923">00130</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Camera.html#a62932b0c160f8a9fbccb7740f6aa2923" title="Fixed axis to yaw around.">mYawFixedAxis</a>;
<a name="l00131"></a>00131 
<a name="l00133"></a><a class="code" href="classOgre_1_1Camera.html#ab8c7f3ed94c7944a4202c40a7cd2e3d8">00133</a>         <a class="code" href="group__General.html#ga68866b02aa7f99e3431337511fbb3345" title="The polygon mode to use when rasterising.">PolygonMode</a> <a class="code" href="classOgre_1_1Camera.html#ab8c7f3ed94c7944a4202c40a7cd2e3d8" title="Rendering type.">mSceneDetail</a>;
<a name="l00134"></a>00134 
<a name="l00136"></a><a class="code" href="classOgre_1_1Camera.html#ad98e861a255945860c8db2918d500e56">00136</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1Camera.html#ad98e861a255945860c8db2918d500e56" title="Stored number of visible faces in the last render.">mVisFacesLastRender</a>;
<a name="l00137"></a>00137 
<a name="l00139"></a><a class="code" href="classOgre_1_1Camera.html#a12079dfb515ba2c7053199bfc37b1ab9">00139</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1Camera.html#a12079dfb515ba2c7053199bfc37b1ab9" title="Stored number of visible faces in the last render.">mVisBatchesLastRender</a>;
<a name="l00140"></a>00140 
<a name="l00142"></a><a class="code" href="classOgre_1_1Camera.html#ab67a882739b1d03debbf3926c4386b02">00142</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Camera.html#ab67a882739b1d03debbf3926c4386b02" title="Shared class-level name for Movable type.">msMovableType</a>;
<a name="l00143"></a>00143 
<a name="l00145"></a><a class="code" href="classOgre_1_1Camera.html#aa29fd57109b30ff640094b5a38d5480c">00145</a>         <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* <a class="code" href="classOgre_1_1Camera.html#aa29fd57109b30ff640094b5a38d5480c" title="SceneNode which this Camera will automatically track.">mAutoTrackTarget</a>;
<a name="l00147"></a><a class="code" href="classOgre_1_1Camera.html#a4f9d27bd6988fdd17e9da6f635053322">00147</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Camera.html#a4f9d27bd6988fdd17e9da6f635053322" title="Tracking offset for fine tuning.">mAutoTrackOffset</a>;
<a name="l00148"></a>00148 
<a name="l00149"></a>00149         <span class="comment">// Scene LOD factor used to adjust overall LOD</span>
<a name="l00150"></a><a class="code" href="classOgre_1_1Camera.html#a5fa6d1429782dc2b48b51e498c04fd3a">00150</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Camera.html#a5fa6d1429782dc2b48b51e498c04fd3a">mSceneLodFactor</a>;
<a name="l00152"></a><a class="code" href="classOgre_1_1Camera.html#a7ba7d1b4ab333a61850ff1fd82481bce">00152</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Camera.html#a7ba7d1b4ab333a61850ff1fd82481bce" title="Inverted scene LOD factor, can be used by Renderables to adjust their LOD.">mSceneLodFactorInv</a>;
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00159"></a><a class="code" href="classOgre_1_1Camera.html#a7891e9715431673c300dfda892c61275">00159</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mWLeft, <a class="code" href="classOgre_1_1Camera.html#a7891e9715431673c300dfda892c61275">mWTop</a>, mWRight, mWBottom;
<a name="l00161"></a><a class="code" href="classOgre_1_1Camera.html#a0420f4f632377b5f9c0a21d09bdd598f">00161</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Camera.html#a0420f4f632377b5f9c0a21d09bdd598f" title="Is viewing window used.">mWindowSet</a>;
<a name="l00163"></a><a class="code" href="classOgre_1_1Camera.html#a408ec27234d6624df6c4c24a7b235d6f">00163</a>         <span class="keyword">mutable</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Plane&gt;::type</a> <a class="code" href="classOgre_1_1Camera.html#a408ec27234d6624df6c4c24a7b235d6f" title="Windowed viewport clip planes.">mWindowClipPlanes</a>;
<a name="l00164"></a>00164         <span class="comment">// Was viewing window changed.</span>
<a name="l00165"></a><a class="code" href="classOgre_1_1Camera.html#aa2002791e4081243682fb9fd3e907c81">00165</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Camera.html#aa2002791e4081243682fb9fd3e907c81">mRecalcWindow</a>;
<a name="l00167"></a><a class="code" href="classOgre_1_1Camera.html#aef0b2465a1c26f55f787b1a5acc8fe43">00167</a>         <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* <a class="code" href="classOgre_1_1Camera.html#aef0b2465a1c26f55f787b1a5acc8fe43" title="The last viewport to be added using this camera.">mLastViewport</a>;
<a name="l00171"></a><a class="code" href="classOgre_1_1Camera.html#a0024729b8a61d3593c5c7b3256a6b59c">00171</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Camera.html#a0024729b8a61d3593c5c7b3256a6b59c" title="Whether aspect ratio will automatically be recalculated when a viewport changes its size...">mAutoAspectRatio</a>;
<a name="l00173"></a><a class="code" href="classOgre_1_1Camera.html#a042156735b9076c83a0a90237e71738f">00173</a>         <a class="code" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent either a vi...">Frustum</a> *<a class="code" href="classOgre_1_1Camera.html#a042156735b9076c83a0a90237e71738f" title="Custom culling frustum.">mCullFrustum</a>;
<a name="l00175"></a><a class="code" href="classOgre_1_1Camera.html#a215f7ec35a41a40b8b89e0a19e438a7a">00175</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Camera.html#a215f7ec35a41a40b8b89e0a19e438a7a" title="Whether or not the rendering distance of objects should take effect for this camera.">mUseRenderingDistance</a>;
<a name="l00177"></a><a class="code" href="classOgre_1_1Camera.html#a67c7dffc7a4ce13d62a1c786245a8f1a">00177</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* <a class="code" href="classOgre_1_1Camera.html#a67c7dffc7a4ce13d62a1c786245a8f1a" title="Camera to use for LOD calculation.">mLodCamera</a>;
<a name="l00178"></a>00178         
<a name="l00180"></a><a class="code" href="classOgre_1_1Camera.html#a043d4085c68a396b2898fbf33c34244f">00180</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Camera.html#a043d4085c68a396b2898fbf33c34244f" title="Whether or not the minimum display size of objects should take effect for this camera.">mUseMinPixelSize</a>;
<a name="l00182"></a><a class="code" href="classOgre_1_1Camera.html#a70d9140f7d51e1b240e2612c95cdaed2">00182</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Camera.html#a70d9140f7d51e1b240e2612c95cdaed2">mPixelDisplayRatio</a>;
<a name="l00183"></a>00183 
<a name="l00184"></a><a class="code" href="classOgre_1_1Camera.html#a9df76bf7f7157636d200458f58c55f31">00184</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Listener*&gt;::type</a> <a class="code" href="classOgre_1_1Camera.html#a9df76bf7f7157636d200458f58c55f31">ListenerList</a>;
<a name="l00185"></a><a class="code" href="classOgre_1_1Camera.html#a8e6f7ca721c90abce31f52b2043eb6ad">00185</a>         <a class="code" href="classOgre_1_1Camera.html#a9df76bf7f7157636d200458f58c55f31">ListenerList</a> <a class="code" href="classOgre_1_1Camera.html#a8e6f7ca721c90abce31f52b2043eb6ad">mListeners</a>;
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188         <span class="comment">// Internal functions for calcs</span>
<a name="l00189"></a>00189         <span class="keywordtype">bool</span> isViewOutOfDate(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00191"></a>00191         <span class="keywordtype">void</span> invalidateFrustum(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00193"></a>00193         <span class="keywordtype">void</span> invalidateView(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00200"></a>00200         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setWindowImpl(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00201"></a>00201 
<a name="l00203"></a>00203         <span class="keyword">virtual</span> <a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">vector&lt;Vector4&gt;::type</a> getRayForwardIntersect(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; anchor, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> *dir, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> planeOffset) <span class="keyword">const</span>;
<a name="l00204"></a>00204 
<a name="l00205"></a>00205     <span class="keyword">public</span>:
<a name="l00208"></a>00208         <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* sm);
<a name="l00209"></a>00209 
<a name="l00212"></a>00212         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>();
<a name="l00213"></a>00213 
<a name="l00215"></a>00215         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addListener(<a class="code" href="classOgre_1_1Camera_1_1Listener.html" title="Listener interface so you can be notified of Camera events.">Listener</a>* l);
<a name="l00217"></a>00217         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeListener(<a class="code" href="classOgre_1_1Camera_1_1Listener.html" title="Listener interface so you can be notified of Camera events.">Listener</a>* l);
<a name="l00218"></a>00218 
<a name="l00221"></a>00221         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* getSceneManager(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00222"></a>00222 
<a name="l00230"></a>00230         <span class="keywordtype">void</span> setPolygonMode(<a class="code" href="group__General.html#ga68866b02aa7f99e3431337511fbb3345" title="The polygon mode to use when rasterising.">PolygonMode</a> sd);
<a name="l00231"></a>00231 
<a name="l00234"></a>00234         <a class="code" href="group__General.html#ga68866b02aa7f99e3431337511fbb3345" title="The polygon mode to use when rasterising.">PolygonMode</a> getPolygonMode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00235"></a>00235 
<a name="l00238"></a>00238         <span class="keywordtype">void</span> setPosition(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z);
<a name="l00239"></a>00239 
<a name="l00242"></a>00242         <span class="keywordtype">void</span> setPosition(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec);
<a name="l00243"></a>00243 
<a name="l00246"></a>00246         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getPosition(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00247"></a>00247 
<a name="l00250"></a>00250         <span class="keywordtype">void</span> move(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec);
<a name="l00251"></a>00251 
<a name="l00254"></a>00254         <span class="keywordtype">void</span> moveRelative(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec);
<a name="l00255"></a>00255 
<a name="l00261"></a>00261         <span class="keywordtype">void</span> setDirection(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z);
<a name="l00262"></a>00262 
<a name="l00265"></a>00265         <span class="keywordtype">void</span> setDirection(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec);
<a name="l00266"></a>00266 
<a name="l00267"></a>00267         <span class="comment">/* Gets the camera&#39;s direction.</span>
<a name="l00268"></a>00268 <span class="comment">        */</span>
<a name="l00269"></a>00269         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> getDirection(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00270"></a>00270 
<a name="l00273"></a>00273         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> getUp(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00274"></a>00274 
<a name="l00277"></a>00277         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> getRight(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00278"></a>00278 
<a name="l00287"></a>00287         <span class="keywordtype">void</span> lookAt( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; targetPoint );
<a name="l00300"></a>00300         <span class="keywordtype">void</span> lookAt(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z);
<a name="l00301"></a>00301 
<a name="l00304"></a>00304         <span class="keywordtype">void</span> roll(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; angle);
<a name="l00305"></a>00305 
<a name="l00308"></a>00308         <span class="keywordtype">void</span> yaw(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; angle);
<a name="l00309"></a>00309 
<a name="l00312"></a>00312         <span class="keywordtype">void</span> pitch(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; angle);
<a name="l00313"></a>00313 
<a name="l00316"></a>00316         <span class="keywordtype">void</span> rotate(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; axis, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; angle);
<a name="l00317"></a>00317 
<a name="l00320"></a>00320         <span class="keywordtype">void</span> rotate(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; q);
<a name="l00321"></a>00321 
<a name="l00341"></a>00341         <span class="keywordtype">void</span> setFixedYawAxis( <span class="keywordtype">bool</span> useFixed, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; fixedAxis = <a class="code" href="classOgre_1_1Vector3.html#a8d1a1f7af535bcc8d9c78b1732bc1b90">Vector3::UNIT_Y</a> );
<a name="l00342"></a>00342 
<a name="l00343"></a>00343 
<a name="l00346"></a>00346         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; getOrientation(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00347"></a>00347 
<a name="l00350"></a>00350         <span class="keywordtype">void</span> setOrientation(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; q);
<a name="l00351"></a>00351 
<a name="l00356"></a>00356         <span class="keywordtype">void</span> _renderScene(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp, <span class="keywordtype">bool</span> includeOverlays);
<a name="l00357"></a>00357 
<a name="l00360"></a>00360         <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="group__General.html#ga6d67d46d838de3b38264f17fb792cddc">operator&lt;&lt;</a>(std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>&amp; c);
<a name="l00361"></a>00361 
<a name="l00364"></a>00364         <span class="keywordtype">void</span> _notifyRenderedFaces(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> numfaces);
<a name="l00365"></a>00365 
<a name="l00368"></a>00368         <span class="keywordtype">void</span> _notifyRenderedBatches(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> numbatches);
<a name="l00369"></a>00369 
<a name="l00372"></a>00372         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _getNumRenderedFaces(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00373"></a>00373 
<a name="l00376"></a>00376         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _getNumRenderedBatches(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00377"></a>00377 
<a name="l00380"></a>00380         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; getDerivedOrientation(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00383"></a>00383         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getDerivedPosition(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00386"></a>00386         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> getDerivedDirection(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00389"></a>00389         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> getDerivedUp(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00392"></a>00392         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> getDerivedRight(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00393"></a>00393 
<a name="l00396"></a>00396         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; getRealOrientation(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00399"></a>00399         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getRealPosition(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00402"></a>00402         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> getRealDirection(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00405"></a>00405         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> getRealUp(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00408"></a>00408         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> getRealRight(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00409"></a>00409 
<a name="l00411"></a>00411         <span class="keywordtype">void</span> getWorldTransforms(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* mat) <span class="keyword">const</span>;
<a name="l00412"></a>00412 
<a name="l00414"></a>00414         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMovableType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00415"></a>00415 
<a name="l00435"></a>00435         <span class="keywordtype">void</span> setAutoTracking(<span class="keywordtype">bool</span> enabled, <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* <span class="keyword">const</span> target = 0, 
<a name="l00436"></a>00436             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; offset = <a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>);
<a name="l00437"></a>00437 
<a name="l00438"></a>00438 
<a name="l00454"></a>00454         <span class="keywordtype">void</span> setLodBias(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> factor = 1.0);
<a name="l00455"></a>00455 
<a name="l00460"></a>00460         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getLodBias(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00461"></a>00461 
<a name="l00474"></a>00474         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setLodCamera(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* lodCam);
<a name="l00475"></a>00475 
<a name="l00482"></a>00482         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* getLodCamera() <span class="keyword">const</span>;
<a name="l00483"></a>00483 
<a name="l00484"></a>00484 
<a name="l00489"></a>00489         <a class="code" href="classOgre_1_1Ray.html" title="Representation of a ray in space, i.e.">Ray</a> getCameraToViewportRay(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> screenx, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> screeny) <span class="keyword">const</span>;
<a name="l00495"></a>00495         <span class="keywordtype">void</span> getCameraToViewportRay(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> screenx, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> screeny, <a class="code" href="classOgre_1_1Ray.html" title="Representation of a ray in space, i.e.">Ray</a>* outRay) <span class="keyword">const</span>;
<a name="l00496"></a>00496 
<a name="l00507"></a>00507         <a class="code" href="classOgre_1_1PlaneBoundedVolume.html" title="Represents a convex volume bounded by planes.">PlaneBoundedVolume</a> getCameraToViewportBoxVolume(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> screenLeft, 
<a name="l00508"></a>00508             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> screenTop, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> screenRight, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> screenBottom, <span class="keywordtype">bool</span> includeFarPlane = <span class="keyword">false</span>);
<a name="l00509"></a>00509 
<a name="l00521"></a>00521         <span class="keywordtype">void</span> getCameraToViewportBoxVolume(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> screenLeft, 
<a name="l00522"></a>00522             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> screenTop, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> screenRight, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> screenBottom, 
<a name="l00523"></a>00523             <a class="code" href="classOgre_1_1PlaneBoundedVolume.html" title="Represents a convex volume bounded by planes.">PlaneBoundedVolume</a>* outVolume, <span class="keywordtype">bool</span> includeFarPlane = <span class="keyword">false</span>);
<a name="l00524"></a>00524 
<a name="l00526"></a>00526         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> _getLodBiasInverse(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00527"></a>00527 
<a name="l00528"></a>00528 
<a name="l00530"></a>00530         <span class="keywordtype">void</span> _autoTrack(<span class="keywordtype">void</span>);
<a name="l00531"></a>00531 
<a name="l00532"></a>00532 
<a name="l00542"></a>00542         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setWindow (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> Left, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> Top, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> Right, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> Bottom);
<a name="l00544"></a>00544         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resetWindow (<span class="keywordtype">void</span>);
<a name="l00546"></a><a class="code" href="classOgre_1_1Camera.html#adb7b6700434dde35e19788d404f96958">00546</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Camera.html#adb7b6700434dde35e19788d404f96958" title="Returns if a viewport window is being used.">isWindowSet</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mWindowSet; }
<a name="l00548"></a>00548         <span class="keyword">const</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Plane&gt;::type</a>&amp; getWindowPlanes(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00549"></a>00549 
<a name="l00551"></a>00551         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getBoundingRadius(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00553"></a><a class="code" href="classOgre_1_1Camera.html#a98c8cdccedb467b664a3f705c37d0321">00553</a>         <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* <a class="code" href="classOgre_1_1Camera.html#a98c8cdccedb467b664a3f705c37d0321" title="Get the auto tracking target for this camera, if any.">getAutoTrackTarget</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mAutoTrackTarget; }
<a name="l00555"></a><a class="code" href="classOgre_1_1Camera.html#aca816b4aae83040da19d12ccd285b1f4">00555</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; <a class="code" href="classOgre_1_1Camera.html#aca816b4aae83040da19d12ccd285b1f4" title="Get the auto tracking offset for this camera, if it is auto tracking.">getAutoTrackOffset</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mAutoTrackOffset; }
<a name="l00556"></a>00556         
<a name="l00562"></a><a class="code" href="classOgre_1_1Camera.html#a3437fc8c00daec1032158a0d92db1071">00562</a>         <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* <a class="code" href="classOgre_1_1Camera.html#a3437fc8c00daec1032158a0d92db1071" title="Get the last viewport which was attached to this camera.">getViewport</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{<span class="keywordflow">return</span> mLastViewport;}
<a name="l00564"></a><a class="code" href="classOgre_1_1Camera.html#ac161a4022d817bf6e595a91cdca84848">00564</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Camera.html#ac161a4022d817bf6e595a91cdca84848" title="Notifies this camera that a viewport is using it.">_notifyViewport</a>(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* viewport) {mLastViewport = viewport;}
<a name="l00565"></a>00565 
<a name="l00573"></a>00573         <span class="keywordtype">void</span> setAutoAspectRatio(<span class="keywordtype">bool</span> autoratio);
<a name="l00574"></a>00574 
<a name="l00577"></a>00577         <span class="keywordtype">bool</span> getAutoAspectRatio(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00578"></a>00578 
<a name="l00590"></a><a class="code" href="classOgre_1_1Camera.html#a6fc2cf5ece7f9466a05066c2162e43d6">00590</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Camera.html#a6fc2cf5ece7f9466a05066c2162e43d6" title="Tells the camera to use a separate Frustum instance to perform culling.">setCullingFrustum</a>(<a class="code" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent either a vi...">Frustum</a>* frustum) { mCullFrustum = frustum; }
<a name="l00592"></a><a class="code" href="classOgre_1_1Camera.html#ad851329e44125406f1adfa9c85c38a4e">00592</a>         <a class="code" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent either a vi...">Frustum</a>* <a class="code" href="classOgre_1_1Camera.html#ad851329e44125406f1adfa9c85c38a4e" title="Returns the custom culling frustum in use.">getCullingFrustum</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mCullFrustum; }
<a name="l00593"></a>00593 
<a name="l00598"></a>00598         <span class="keyword">virtual</span> <span class="keywordtype">void</span> forwardIntersect(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; worldPlane, <a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">vector&lt;Vector4&gt;::type</a>* intersect3d) <span class="keyword">const</span>;
<a name="l00599"></a>00599 
<a name="l00601"></a>00601         <span class="keywordtype">bool</span> isVisible(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; bound, <a class="code" href="group__Math.html#ga62275d08557868fd87154c46dfcc9dfd" title="Worldspace clipping planes.">FrustumPlane</a>* culledBy = 0) <span class="keyword">const</span>;
<a name="l00603"></a>00603         <span class="keywordtype">bool</span> isVisible(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>&amp; bound, <a class="code" href="group__Math.html#ga62275d08557868fd87154c46dfcc9dfd" title="Worldspace clipping planes.">FrustumPlane</a>* culledBy = 0) <span class="keyword">const</span>;
<a name="l00605"></a>00605         <span class="keywordtype">bool</span> isVisible(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vert, <a class="code" href="group__Math.html#ga62275d08557868fd87154c46dfcc9dfd" title="Worldspace clipping planes.">FrustumPlane</a>* culledBy = 0) <span class="keyword">const</span>;
<a name="l00607"></a>00607         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>* getWorldSpaceCorners(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00609"></a>00609         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; getFrustumPlane( <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> plane ) <span class="keyword">const</span>;
<a name="l00611"></a>00611         <span class="keywordtype">bool</span> projectSphere(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>&amp; sphere, 
<a name="l00612"></a>00612             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* left, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* top, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* right, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* bottom) <span class="keyword">const</span>;
<a name="l00614"></a>00614         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getNearClipDistance(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00616"></a>00616         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getFarClipDistance(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00618"></a>00618         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; getViewMatrix(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00627"></a>00627         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; getViewMatrix(<span class="keywordtype">bool</span> ownFrustumOnly) <span class="keyword">const</span>;
<a name="l00633"></a><a class="code" href="classOgre_1_1Camera.html#af0f02c8ac7e6dc46ae6cd8ee209abd8e">00633</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Camera.html#af0f02c8ac7e6dc46ae6cd8ee209abd8e" title="Set whether this camera should use the &#39;rendering distance&#39; on objects to exclude distant objects fro...">setUseRenderingDistance</a>(<span class="keywordtype">bool</span> use) { mUseRenderingDistance = use; }
<a name="l00637"></a><a class="code" href="classOgre_1_1Camera.html#ad54f2ad84c21d593c5efa61173eccdfc">00637</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Camera.html#ad54f2ad84c21d593c5efa61173eccdfc" title="Get whether this camera should use the &#39;rendering distance&#39; on objects to exclude distant objects fro...">getUseRenderingDistance</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseRenderingDistance; }
<a name="l00638"></a>00638 
<a name="l00645"></a>00645         <span class="keyword">virtual</span> <span class="keywordtype">void</span> synchroniseBaseSettingsWith(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l00646"></a>00646 
<a name="l00648"></a>00648         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getPositionForViewUpdate(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00650"></a>00650         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; getOrientationForViewUpdate(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00651"></a>00651 
<a name="l00657"></a><a class="code" href="classOgre_1_1Camera.html#a62d47145eb99e07af3de0915645be07c">00657</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Camera.html#a62d47145eb99e07af3de0915645be07c" title="Sets whether to use min display size calculations When active objects who&#39;s size on the screen is les...">setUseMinPixelSize</a>(<span class="keywordtype">bool</span> enable) { mUseMinPixelSize = enable; }
<a name="l00661"></a><a class="code" href="classOgre_1_1Camera.html#a82c8dc6194519f1bc142b8822077f9fa">00661</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Camera.html#a82c8dc6194519f1bc142b8822077f9fa" title="Returns whether to use min display size calculations.">getUseMinPixelSize</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseMinPixelSize; }
<a name="l00662"></a>00662 
<a name="l00673"></a><a class="code" href="classOgre_1_1Camera.html#a36a9ab64e972cc1af42d4e634a50e516">00673</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Camera.html#a36a9ab64e972cc1af42d4e634a50e516" title="Returns an estimated ratio between a pixel and the display area it represents.">getPixelDisplayRatio</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mPixelDisplayRatio; }
<a name="l00674"></a>00674         
<a name="l00675"></a>00675      };
<a name="l00679"></a>00679 } <span class="comment">// namespace Ogre</span>
<a name="l00680"></a>00680 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
